/*
   UM.C unmangle C++ names in a map file.

   This program may be freely distributed provided it is included with the
   file unmangle.c. This program is provided 'as is' with no warrantees as
   to its suitability for any usage, whether implied or otherwise.
   
   This file can be compiled as is with Zortech C++ v2 and will produce an
   executable which can be run on a map file to demonstrate the use of the
   name unmangling functions.
   
   compile with:

   	ztc -mti um unmangle

   and the usage is:

   	um [mapfile]
   	
   the name unmangled output is sent to stdout and can be redirected to
   a file.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *unmangle_str(char *);

main(argc, argv)
int argc;
char *argv[];
{
	FILE *fp;
	char mapfile[13], *line, *s, *s0, *s1;
	int x;

	if (argc > 1) {
		strcpy(mapfile,argv[1]);
	} else {
		printf("Usage is um [mapfile]\n");
		exit(EXIT_FAILURE);
	}


	if ((fp = fopen(mapfile,"r")) == NULL) {
		printf("Mapfile %s not found\n",mapfile);
		exit(EXIT_FAILURE);
	}
	
	line = malloc(255);
	
	while (fgets(line,255,fp)) {
		s = NULL;
		if ((s0 = strchr(line,'_')) != NULL) {
			s1 = s0;
			while (!iscntrl(*s1))
				if (isspace(*s1) || *s1 == 39)
					break;
				else
					s1++;
			s = unmangle_str(s0);
		}
		if (s) {
			*s0 = 0;
			printf("%s%s%s",line,s,s1);
			free(s);
		} else
			printf("%s",line);
	}
	free(line);
	fclose(fp);
	return EXIT_SUCCESS;
}

