/* UMLINK.C a program that makes use of pipes to unmangle the output from
   Zortech BLINK and Microsoft LINK.

   This program may be freely distributed provided it is included with the
   file unmangle.c. This program is provided 'as is' with no warrantees as
   to its suitability for any usage, whether implied or otherwise.
   
   This file can be compiled as is with Zortech C++ v2 and will produce an
   executable which can be used as a pipe  to demonstrate the use of the
   name unmangling functions.
   
   compile with:

   	ztc -mti umlink unmangle

   and the usage is:

   	ztc {flags} [sourcefiles]  |umlink
   
   try the example
   
    ztc test |umlink
   	
   the name unmangled output is sent to stdout and can be redirected to
   a file.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *unmangle_str(char *);

main()
{
	char buf[255], *s,*s0, *s1;
	int i, flag = 0;
	
	while (gets(buf)) {
		s = NULL;
		if ((s0 = strchr(buf,'_')) != NULL) {
			s1 = s0;
			while (!iscntrl(*s1))
				if (isspace(*s1))
					break;
				else
					s1++;
			s = unmangle_str(s0);
		}
		if (s) {
			*s0 = 0;
			printf("%s%s%s\n",buf,s,s1);
			free(s);
		} else
			printf("%s\n",buf);
	}
		
	exit(EXIT_SUCCESS);
}
	
